Factor_regression_Imputed_CCA<-function(f, y){
  
  data = data.frame(cbind(f[,1:M0]), y)
  data$y = factor(data$y)
  mult.model = multinom(y ~ .-1, data = data, MaxNWts = 10000)
  predlab = predict(mult.model, newdata = data, type = "class")
  
  summary = multiClassSummary(
    data.frame(obs = data$y, pred = predlab), lev = levels(data$y))
  Accuracy = summary[1]
  F1 = summary[3]
  Precision = summary[8]
  Recall = summary[9]
  AIC = mult.model$AIC
  
  return(list(Accuracy, Precision, Recall, F1, AIC))
  
}