MCCA <- function(x_co, k1, k2, t.1h, t.2h){
  
  #################################################
  ##### Computing the FPC scores and curves for each data source by SVD method #############
  
  s1<-svd(x_co[,1:T1]/sqrt(N) )                                         ## SVD for x.1 on the all data 
  phi.1.hat<-t(s1$v[,1:k1]) * (t.1h/T1)^(-0.5)                          ## The univariate FPC curves of x.1 with order k1*T1
  x.1.score<-x_co[,1:T1] %*% t(phi.1.hat) * (t.1h/T1)                   ## The univariate FPC scores of x.1 with order N*k1
  
  s2<-svd(x_co[,(T1+1):(T1+T2)]/sqrt(N) )                               ## SVD for x.2 on the all data 
  phi.2.hat<-t(s2$v[,1:k2]) * (t.2h/T2)^(-0.5)                          ##  The univariate FPC curves of x.2 with orderk2*T2
  x.2.score<-x_co[,(T1+1):(T1+T2)] %*% t(phi.2.hat) * (t.2h/T2)         ##  The univariate FPC score of x.2 with order N*k2
  
  ##### The end of Computing the FPC scores and curves for each data source by SVD method #############  
  #################################################
  
  
  #################################################
  ##### Computing the Canonical scores #############
  
  Z1 = x.1.score
  Z2 = x.2.score
  
  Omega1 = Z1%*%solve(t(Z1)%*%Z1)%*%t(Z1)
  Omega2 = Z2%*%solve(t(Z2)%*%Z2)%*%t(Z2)
  
  evd = eigen(Omega1 + Omega2)
  
  f.hat = evd$vectors[,1:M0] 
  
  #####The end of  Computing the Canonical scores #############
  #################################################
  
  return(list(f.hat))
  
}