generate_data_setting1_gamma<-function(phi.1, phi.2, alpha1, alpha2, alpha3, sd, gamma){
  
  psi.1 <- phi.1*sqrt(gamma)              ### (M11 * M12) * (T11 * T12) tensor
  psi.2 <- phi.2*sqrt(1-gamma)            ### M2 * T2 matrix
  
  ## Generating the 2-source functional data ########
  rho = apply(matrix(1:M2,nrow=M2,ncol=1), 1, function(x){return(rnorm(N,0,(exp(-(1+x)/2))^0.5))})   ### Multivariate Functional PC scores matrix with order N*M2 based on Covariance matrix
  x.1 = rho %*% psi.1                                       # N * T1 matrix  of 1st data source: Image x(1)                        
  x.2 = rho %*% psi.2                                       # N * T2  matrix of 2nd data source: curve x(2)
  x = cbind(x.1,x.2)                                        # N * (T1+T2)  matrix of 2-source data x
  ## The end of Generating the 2-source functional data ########
  
  rho_std = scale(rho)
  p.1 = exp(rho_std[,1:M]%*% alpha1)/(exp(rho_std[,1:M]%*% alpha1)+exp(rho_std[,1:M]%*% alpha2)+exp(rho_std[,1:M]%*% alpha3))
  p.2 = exp(rho_std[,1:M]%*% alpha2)/(exp(rho_std[,1:M]%*% alpha1)+exp(rho_std[,1:M]%*% alpha2)+exp(rho_std[,1:M]%*% alpha3))
  p.3 = exp(rho_std[,1:M]%*% alpha3)/(exp(rho_std[,1:M]%*% alpha1)+exp(rho_std[,1:M]%*% alpha2)+exp(rho_std[,1:M]%*% alpha3))
  p.0 = cbind(p.1, p.2, p.3)
  
  y=c()
  for(i in 1:N){
    y0 = which.max(rmultinom(1, size = 1, prob = p.0[i,]))
    y=c(y,y0)
  }
  
  return(list(rho_std, x, y, psi.1, psi.2))
  
}