generate_eigenfunction_setting1<-function(N, M1, T1, M2, T2){
  
  fai.1<-eFun(seq(0,4,length.out = T1), M = M1, type = "Fourier")  # the first one is the Fourier basis defined on the interval [0,4]
  fai.2<-eFun(seq(-1,1,length.out = T2), M = M2, type = "Wiener")  # the second one is the Wiener basis defined on the interval [-1,1]
  
  t.1<-fai.1@argvals[[1]]
  t.1h<-t.1[T1]-t.1[1]
  
  t.2<-fai.2@argvals[[1]]
  t.2h<-t.2[T2]-t.2[1]
  
  phi.1<-fai.1@X  # phi.1 is an M1*T1 matrix
  phi.2<-fai.2@X  # phi.2 is an M2*T2 matrix
  
  return(list(t.1, t.2, phi.1, phi.2,  t.1h, t.2h))
  
}
