generate_missing_pattern<-function(rho, x, y){
  
  id1 = which(y == 1)
  id2 = which(y == 2)
  id3 = which(y == 3)
  
  x.1 = x[,1:T1]
  x.2 = x[,(T1+1):(T1+T2)]
  
  
  ## Divide the missing block when y = 1 ##
  g1.1 = x.1[id1,]%*%gam1.1[1:T1]/T1 + x.2[id1,]%*%gam1.1[(T1+1):(T1+T2)]/T2
  g1.2 = x.1[id1,]%*%gam1.2[1:T1]/T1 + x.2[id1,]%*%gam1.2[(T1+1):(T1+T2)]/T2
  g1.3 = x.1[id1,]%*%gam1.3[1:T1]/T1 + x.2[id1,]%*%gam1.3[(T1+1):(T1+T2)]/T2
  
  p1.1 = g1.1 / (g1.1+g1.2+g1.3)
  p1.2 = g1.2 / (g1.1+g1.2+g1.3)
  p1.3 = g1.3 / (g1.1+g1.2+g1.3)
  p1 = cbind(p1.1, p1.2, p1.3)
  
  miss.1 = c()
  for(i in 1:length(id1)){
    miss0.1 = which.max(rmultinom(1, size = 1, prob = p1[i,]))
    miss.1 = c(miss.1, miss0.1)
  }
  
  id1.1 = which(miss.1 == 1)
  id1.2 = which(miss.1 == 2)
  id1.3 = which(miss.1 == 3)
  ## The end of dividing the missing block when y = 1 ##
  
  
  ## Divide the missing block when y = 2 ##
  g2.1 = x.1[id2,]%*%gam2.1[1:T1]/T1 + x.2[id2,]%*%gam2.1[(T1+1):(T1+T2)]/T2
  g2.2 = x.1[id2,]%*%gam2.2[1:T1]/T1 + x.2[id2,]%*%gam2.2[(T1+1):(T1+T2)]/T2
  g2.3 = x.1[id2,]%*%gam2.3[1:T1]/T1 + x.2[id2,]%*%gam2.3[(T1+1):(T1+T2)]/T2
  
  p2.1 = g2.1 / (g2.1+g2.2+g2.3)
  p2.2 = g2.2 / (g2.1+g2.2+g2.3)
  p2.3 = g2.3 / (g2.1+g2.2+g2.3)
  p2 = cbind(p2.1, p2.2, p2.3)
  
  miss.2 = c()
  for(i in 1:length(id2)){
    miss0.2 = which.max(rmultinom(1, size = 1, prob = p2[i,]))
    miss.2 = c(miss.2, miss0.2)
  }
  
  id2.1 = which(miss.2 == 1)
  id2.2 = which(miss.2 == 2)
  id2.3 = which(miss.2 == 3)
  ## The end of dividing the missing block when y = 2 ##
  
  
  ## Divide the missing block when y = 3 ##
  g3.1 = x.1[id3,]%*%gam3.1[1:T1]/T1 + x.2[id3,]%*%gam3.1[(T1+1):(T1+T2)]/T2
  g3.2 = x.1[id3,]%*%gam3.2[1:T1]/T1 + x.2[id3,]%*%gam3.2[(T1+1):(T1+T2)]/T2
  g3.3 = x.1[id3,]%*%gam3.3[1:T1]/T1 + x.2[id3,]%*%gam3.3[(T1+1):(T1+T2)]/T2
  
  p3.1 = g3.1 / (g3.1+g3.2+g3.3)
  p3.2 = g3.2 / (g3.1+g3.2+g3.3)
  p3.3 = g3.3 / (g3.1+g3.2+g3.3)
  p3 = cbind(p3.1, p3.2, p3.3)
  
  miss.3 = c()
  for(i in 1:length(id3)){
    miss0.3 = which.max(rmultinom(1, size = 1, prob = p3[i,]))
    miss.3 = c(miss.3, miss0.3)
  }
  
  id3.1 = which(miss.3 == 1)
  id3.2 = which(miss.3 == 2)
  id3.3 = which(miss.3 == 3)
  ## The end of dividing the missing block when y = 3 ##
  
  
  ## Divide the missing block ##
  id.1 = c(id1[id1.1], id2[id2.1], id3[id3.1])
  id.2 = c(id1[id1.2], id2[id2.2], id3[id3.2])
  id.3 = c(id1[id1.3], id2[id2.3], id3[id3.3])
  
  NN = c()
  NN[1] = length(id.1)
  NN[2] = length(id.2)
  NN[3] = length(id.3)
  
  y.new = c(y[id.1], y[id.2], y[id.3])
  x.new = rbind(x[id.1,], x[id.2,], x[id.3,])
  rho.new = rbind(rho[id.1,], rho[id.2,], rho[id.3,])
  ## The end of dividing the missing block ##
  
  
  return(list(NN, rho.new, x.new, y.new))
  
}