Construct_factor_CCA = function(x_std, psi.1.hat, psi.2.hat, psi.3.hat,
                                x.1.score_NA, x.2.score_NA, x.3.score_NA){
  
  score<-cbind(x.1.score_NA, x.2.score_NA, x.3.score_NA)
  
  z.hat<-t(score) %*% score /(N-1)
  
  rho.hat_std_temp<-x.1.score_NA%*% eigen(z.hat)$vec[1:k1,1:(k1+k2+k3)] +
    x.2.score_NA%*% eigen(z.hat)$vec[(k1+1):(k1+k2),1:(k1+k2+k3)] +
    x.3.score_NA%*% eigen(z.hat)$vec[(k1+k2+1):(k1+k2+k3),1:(k1+k2+k3)] # Estimated MFPC scores with order N*(k1+k2+k3) based on the correlation matrix
  
  x.hat_std<-rho.hat_std_temp %*% cbind(psi.1.hat,psi.2.hat,psi.3.hat)

  rho.hat_std<-scale(rho.hat_std_temp)[,1:M0]
  
  x_std[c((sum(NN[1:3])+1):sum(NN[1:4]),(sum(NN[1:5])+1):sum(NN[1:7])),1:T1]<-
    x.hat_std[c((sum(NN[1:3])+1):sum(NN[1:4]),(sum(NN[1:5])+1):sum(NN[1:7])),1:T1]
  x_std[c((sum(NN[1:2])+1):sum(NN[1:3]),(sum(NN[1:4])+1):sum(NN[1:5]),(sum(NN[1:6])+1):sum(NN[1:7])),(T1+1):(T1+T2)]<-
    x.hat_std[c((sum(NN[1:2])+1):sum(NN[1:3]),(sum(NN[1:4])+1):sum(NN[1:5]),(sum(NN[1:6])+1):sum(NN[1:7])),(T1+1):(T1+T2)]
  x_std[c((NN[1]+1):sum(NN[1:2]),(sum(NN[1:4])+1):sum(NN[1:6])),(T1+T2+1):(T1+T2+T3)]<-
    x.hat_std[c((NN[1]+1):sum(NN[1:2]),(sum(NN[1:4])+1):sum(NN[1:6])),(T1+T2+1):(T1+T2+T3)] 
  
  Z1 = x.1.score_NA
  Z2 = x.2.score_NA
  Z3 = x.3.score_NA
  
  Omega1 = Z1%*%solve(t(Z1)%*%Z1)%*%t(Z1)
  Omega2 = Z2%*%solve(t(Z2)%*%Z2)%*%t(Z2)
  Omega3 = Z3%*%solve(t(Z3)%*%Z3)%*%t(Z3)
  
  evd = eigen(Omega1 + Omega2 + Omega2)
  f.hat = evd$vectors[,1:M0] 
  
  return(list(f.hat, x_std))
  
}