generate_data_setting2<-function(phi.1,phi.2,phi.3,alpha1,alpha2,alpha3,sd,gamma1,gamma2){
  
  dim(phi.1)<-c((M11*M12),(T11*T12))               ## Transfoming the tensor into matrix 
  psi.1 <- phi.1*sqrt(1-gamma1-gamma2)             ### (M11 * M12) * (T11 * T12) tensor
  psi.2 <- phi.2*sqrt(gamma1)                      ### M2 * T2 matrix
  psi.3 <- phi.3*sqrt(gamma2)                      ### M3 * T3 matrix
  
  rho<-apply(matrix(1:M2,nrow=M2,ncol=1), 1, 
             function(x){return(rnorm(N,0,(exp(-(1+x)/2))^0.5))})
  
  x.1<-rho %*% psi.1                             ## N * T1 matrix  of 1st data source: Image x(1) 
  x.2<-rho %*% psi.2                             ## N * T2 matrix  of 2nd data source: curve x(2) 
  x.3<-rho %*% psi.3                             ## N * T3 matrix  of 3rd data source: curve x(3) 
  x<-cbind(x.1,x.2,x.3)                          ## N * (T1+T2+T3)  matrix of 3-source data x

  rho_std = scale(rho)
  p1 = exp(rho_std[,1:M]%*% alpha1)/(exp(rho_std[,1:M]%*% alpha1)+exp(rho_std[,1:M]%*% alpha2)+exp(rho_std[,1:M]%*% alpha3))
  p2 = exp(rho_std[,1:M]%*% alpha2)/(exp(rho_std[,1:M]%*% alpha1)+exp(rho_std[,1:M]%*% alpha2)+exp(rho_std[,1:M]%*% alpha3))
  p3 = exp(rho_std[,1:M]%*% alpha3)/(exp(rho_std[,1:M]%*% alpha1)+exp(rho_std[,1:M]%*% alpha2)+exp(rho_std[,1:M]%*% alpha3))
  p = cbind(p1, p2, p3)
  
  y=c()
  for(i in 1:N){
    y0 = which.max(rmultinom(1, size = 1, prob = p[i,]))
    y=c(y,y0)
  }
  
  return(list(rho_std, x, y, psi.1, psi.2, psi.3))
  
}