Factor_regression_Imputed_PCA<-function(rho.hat_std, alpha2, alpha3, y){
  
  data = data.frame(cbind(rho.hat_std[,1:M0]), y)
  data$y = factor(data$y)
  mult.model = multinom(y ~ .-1, data = data, MaxNWts = 10000)
  predlab = predict(mult.model, newdata = data, type = "class")
  summary = multiClassSummary(
    data.frame(obs = data$y, pred = predlab), lev = levels(data$y))
  
  alpha2.hat = abs(summary(mult.model)$coefficients[1,])
  alpha3.hat = abs(summary(mult.model)$coefficients[2,])
  
  mse_alpha2 = mean(na.omit((alpha2-alpha2.hat[1:M]))^2)
  mse_alpha3 = mean(na.omit((alpha3-alpha3.hat[1:M]))^2)
  
  Accuracy = summary[1]
  F1 = summary[3]
  Precision = summary[8]
  Recall = summary[9]
  AIC = mult.model$AIC
  
  return(list(Accuracy, Precision, Recall, F1, AIC, 
              alpha2.hat, alpha3.hat, mse_alpha2, mse_alpha3))
  
}