MCCA_setting2 <- function(x_co, k1, k2, k3, t.1h, t.2h, t.3h){
  
  #################################################
  ##### Computing the FPC scores and curves for each data source by SVD method #############
  
  s1<-svd(x_co[,1:T1]/sqrt(N))
  phi.1.hat<-t(s1$v[,1:k1]) * (t.1h/T1)^(-0.5)
  x.1.score<-x_co[,1:T1] %*% t(phi.1.hat) * (t.1h/T1) #The univariate FPCA of x.1
  
  s2<-svd(x_co[,(T1+1):(T1+T2)]/sqrt(N))
  phi.2.hat<-t(s2$v[,1:k2]) * (t.2h/T2)^(-0.5)
  x.2.score<-x_co[,(T1+1):(T1+T2)] %*% t(phi.2.hat) * (t.2h/T2) #The univariate FPCA of x.2
  
  s3<-svd(x_co[,(T1+T2+1):(T1+T2+T3)]/sqrt(N))
  phi.3.hat<-t(s3$v[,1:k3]) * (t.3h/T3)^(-0.5)
  x.3.score<-x_co[,(T1+T2+1):(T1+T2+T3)] %*% t(phi.3.hat) * (t.3h/T3) #The univariate FPCA of x.3
  
  ##### The end of Computing the FPC scores and curves for each data source by SVD method #############  
  #################################################
  
  
  #################################################
  ##### Computing the Canonical scores #############
  
  Z1 = x.1.score
  Z2 = x.2.score
  Z3 = x.3.score
  
  Omega1 = Z1%*%solve(t(Z1)%*%Z1)%*%t(Z1)
  Omega2 = Z2%*%solve(t(Z2)%*%Z2)%*%t(Z2)
  Omega3 = Z3%*%solve(t(Z3)%*%Z3)%*%t(Z3)
  
  evd = eigen(Omega1 + Omega2 + Omega3)
  
  f.hat = evd$vectors[,1:M0] 
  
  #####The end of  Computing the Canonical scores #############
  #################################################
  
  return(list(f.hat))
  
}