generate_eigenfunction_setting2<-function(N, M11, T11, M12, T12, M2, T2, M3, T3){
  
  tensor.product<-function(V,W){
    V.W<-array(0,dim=c(nrow(V@X)*nrow(W@X), ncol(V@X), ncol(W@X)))
    for (i in 1:nrow(V@X)) {
      for (j in 1:nrow(W@X)) {
        V.W[(i-1)*nrow(V@X)+j,,]<-V@X[i,] %*% t(W@X[j,])
      }
    }
    return(V.W)
  }
  
  # Fourier basis 
  V<-eFun(seq(0,1,length.out = T11), M = M11, type = "Fourier")   # T11 * M11 matrix
  W<-eFun(seq(0,0.5,length.out = T12), M = M12, type = "Fourier") # T12 * M12 matrix
  
  phi.1<-tensor.product(V, W)   #(M11 * M12) * T11 * T12 tensor
  t.11<-seq(0,1,length.out = T11)
  t.12<-seq(0,0.5,length.out = T12)
  t.1h<-(t.11[T11]-t.11[1])*(t.12[T12]-t.12[1])
 
  
  fai.2<-eFun(seq(-1,1,length.out = T2), M = M2, type = "Poly")
  t.2<-fai.2@argvals[[1]]
  t.2h<-t.2[T2]-t.2[1]
  phi.2<-fai.2@X # phi.2 is an M2*T2 matrix
 
  
  fai.3<-eFun(seq(0,2,length.out = T3), M = M3, type = "Fourier")
  t.3<-fai.2@argvals[[1]]
  t.3h<-t.3[T3]-t.3[1]
  phi.3<-fai.3@X # phi.3 is an M3*T3 matrix
  
  return(list(t.11, t.12, t.2, t.3, phi.1, phi.2, phi.3, t.1h, t.2h, t.3h))
  
}