generate_missing_pattern<-function(rho, x, y){
  
  id1 = which(y == 1)
  id2 = which(y == 2)
  id3 = which(y == 3)
  
  x.1 = x[,1:T1]
  x.2 = x[,(T1+1):(T1+T2)]
  x.3 = x[,(T1+T2+1):(T1+T2+T3)]
  
  ## Divide the missing block when y = 1 ##
  g1.1 = x.1[id1,]%*%gam1.1[1:T1]/T1 + x.2[id1,]%*%gam1.1[(T1+1):(T1+T2)]/T2 + x.3[id1,]%*%gam1.1[(T1+T2+1):(T1+T2+T3)]/T3
  g1.2 = x.1[id1,]%*%gam1.2[1:T1]/T1 + x.2[id1,]%*%gam1.2[(T1+1):(T1+T2)]/T2 + x.3[id1,]%*%gam1.2[(T1+T2+1):(T1+T2+T3)]/T3
  g1.3 = x.1[id1,]%*%gam1.3[1:T1]/T1 + x.2[id1,]%*%gam1.3[(T1+1):(T1+T2)]/T2 + x.3[id1,]%*%gam1.3[(T1+T2+1):(T1+T2+T3)]/T3
  g1.4 = x.1[id1,]%*%gam1.4[1:T1]/T1 + x.2[id1,]%*%gam1.4[(T1+1):(T1+T2)]/T2 + x.3[id1,]%*%gam1.4[(T1+T2+1):(T1+T2+T3)]/T3
  g1.5 = x.1[id1,]%*%gam1.5[1:T1]/T1 + x.2[id1,]%*%gam1.5[(T1+1):(T1+T2)]/T2 + x.3[id1,]%*%gam1.5[(T1+T2+1):(T1+T2+T3)]/T3
  g1.6 = x.1[id1,]%*%gam1.6[1:T1]/T1 + x.2[id1,]%*%gam1.6[(T1+1):(T1+T2)]/T2 + x.3[id1,]%*%gam1.6[(T1+T2+1):(T1+T2+T3)]/T3
  g1.7 = x.1[id1,]%*%gam1.7[1:T1]/T1 + x.2[id1,]%*%gam1.7[(T1+1):(T1+T2)]/T2 + x.3[id1,]%*%gam1.7[(T1+T2+1):(T1+T2+T3)]/T3
  
  p1.1 = g1.1 / (g1.1+g1.2+g1.3+g1.4+g1.5+g1.6+g1.7)
  p1.2 = g1.2 / (g1.1+g1.2+g1.3+g1.4+g1.5+g1.6+g1.7)
  p1.3 = g1.3 / (g1.1+g1.2+g1.3+g1.4+g1.5+g1.6+g1.7)
  p1.4 = g1.4 / (g1.1+g1.2+g1.3+g1.4+g1.5+g1.6+g1.7)
  p1.5 = g1.5 / (g1.1+g1.2+g1.3+g1.4+g1.5+g1.6+g1.7)
  p1.6 = g1.6 / (g1.1+g1.2+g1.3+g1.4+g1.5+g1.6+g1.7)
  p1.7 = g1.7 / (g1.1+g1.2+g1.3+g1.4+g1.5+g1.6+g1.7)
  p1 = cbind(p1.1, p1.2, p1.3, p1.4, p1.5, p1.6, p1.7)
  
  miss.1 = c()
  for(i in 1:length(id1)){
    miss0.1 = which.max(rmultinom(1, size = 1, prob = p1[i,]))
    miss.1 = c(miss.1, miss0.1)
  }
  
  id1.1 = which(miss.1 == 1)
  id1.2 = which(miss.1 == 2)
  id1.3 = which(miss.1 == 3)
  id1.4 = which(miss.1 == 4)
  id1.5 = which(miss.1 == 5)
  id1.6 = which(miss.1 == 6)
  id1.7 = which(miss.1 == 7)
  ## The end of dividing the missing block when y = 1 ##
  
  
  ## Divide the missing block when y = 2 ##
  g2.1 = x.1[id2,]%*%gam2.1[1:T1]/T1 + x.2[id2,]%*%gam2.1[(T1+1):(T1+T2)]/T2 + x.3[id2,]%*%gam2.1[(T1+T2+1):(T1+T2+T3)]/T3
  g2.2 = x.1[id2,]%*%gam2.2[1:T1]/T1 + x.2[id2,]%*%gam2.2[(T1+1):(T1+T2)]/T2 + x.3[id2,]%*%gam2.2[(T1+T2+1):(T1+T2+T3)]/T3
  g2.3 = x.1[id2,]%*%gam2.3[1:T1]/T1 + x.2[id2,]%*%gam2.3[(T1+1):(T1+T2)]/T2 + x.3[id2,]%*%gam2.3[(T1+T2+1):(T1+T2+T3)]/T3
  g2.4 = x.1[id2,]%*%gam2.4[1:T1]/T1 + x.2[id2,]%*%gam2.4[(T1+1):(T1+T2)]/T2 + x.3[id2,]%*%gam2.4[(T1+T2+1):(T1+T2+T3)]/T3
  g2.5 = x.1[id2,]%*%gam2.5[1:T1]/T1 + x.2[id2,]%*%gam2.5[(T1+1):(T1+T2)]/T2 + x.3[id2,]%*%gam2.5[(T1+T2+1):(T1+T2+T3)]/T3
  g2.6 = x.1[id2,]%*%gam2.6[1:T1]/T1 + x.2[id2,]%*%gam2.6[(T1+1):(T1+T2)]/T2 + x.3[id2,]%*%gam2.6[(T1+T2+1):(T1+T2+T3)]/T3
  g2.7 = x.1[id2,]%*%gam2.7[1:T1]/T1 + x.2[id2,]%*%gam2.7[(T1+1):(T1+T2)]/T2 + x.3[id2,]%*%gam2.7[(T1+T2+1):(T1+T2+T3)]/T3
  
  
  p2.1 = g2.1 / (g2.1+g2.2+g2.3+g2.4+g2.5+g2.6+g2.7)
  p2.2 = g2.2 / (g2.1+g2.2+g2.3+g2.4+g2.5+g2.6+g2.7)
  p2.3 = g2.3 / (g2.1+g2.2+g2.3+g2.4+g2.5+g2.6+g2.7)
  p2.4 = g2.4 / (g2.1+g2.2+g2.3+g2.4+g2.5+g2.6+g2.7)
  p2.5 = g2.5 / (g2.1+g2.2+g2.3+g2.4+g2.5+g2.6+g2.7)
  p2.6 = g2.6 / (g2.1+g2.2+g2.3+g2.4+g2.5+g2.6+g2.7)
  p2.7 = g2.7 / (g2.1+g2.2+g2.3+g2.4+g2.5+g2.6+g2.7)
  
  p2 = cbind(p2.1, p2.2, p2.3, p2.4, p2.5, p2.6, p2.7)
  
  miss.2 = c()
  for(i in 1:length(id2)){
    miss0.2 = which.max(rmultinom(1, size = 1, prob = p2[i,]))
    miss.2 = c(miss.2, miss0.2)
  }
  
  id2.1 = which(miss.2 == 1)
  id2.2 = which(miss.2 == 2)
  id2.3 = which(miss.2 == 3)
  id2.4 = which(miss.2 == 4)
  id2.5 = which(miss.2 == 5)
  id2.6 = which(miss.2 == 6)
  id2.7 = which(miss.2 == 7)
  ## The end of dividing the missing block when y = 2 ##
  
  
  ## Divide the missing block when y = 3 ##
  g3.1 = x.1[id3,]%*%gam3.1[1:T1]/T1 + x.2[id3,]%*%gam3.1[(T1+1):(T1+T2)]/T2 + x.3[id3,]%*%gam3.1[(T1+T2+1):(T1+T2+T3)]/T3
  g3.2 = x.1[id3,]%*%gam3.2[1:T1]/T1 + x.2[id3,]%*%gam3.2[(T1+1):(T1+T2)]/T2 + x.3[id3,]%*%gam3.2[(T1+T2+1):(T1+T2+T3)]/T3
  g3.3 = x.1[id3,]%*%gam3.3[1:T1]/T1 + x.2[id3,]%*%gam3.3[(T1+1):(T1+T2)]/T2 + x.3[id3,]%*%gam3.3[(T1+T2+1):(T1+T2+T3)]/T3
  g3.4 = x.1[id3,]%*%gam3.4[1:T1]/T1 + x.2[id3,]%*%gam3.4[(T1+1):(T1+T2)]/T2 + x.3[id3,]%*%gam3.4[(T1+T2+1):(T1+T2+T3)]/T3
  g3.5 = x.1[id3,]%*%gam3.5[1:T1]/T1 + x.2[id3,]%*%gam3.5[(T1+1):(T1+T2)]/T2 + x.3[id3,]%*%gam3.5[(T1+T2+1):(T1+T2+T3)]/T3
  g3.6 = x.1[id3,]%*%gam3.6[1:T1]/T1 + x.2[id3,]%*%gam3.6[(T1+1):(T1+T2)]/T2 + x.3[id3,]%*%gam3.6[(T1+T2+1):(T1+T2+T3)]/T3
  g3.7 = x.1[id3,]%*%gam3.7[1:T1]/T1 + x.2[id3,]%*%gam3.7[(T1+1):(T1+T2)]/T2 + x.3[id3,]%*%gam3.7[(T1+T2+1):(T1+T2+T3)]/T3
  
  p3.1 = g3.1 / (g3.1+g3.2+g3.3+g3.4+g3.5+g3.6+g3.7)
  p3.2 = g3.2 / (g3.1+g3.2+g3.3+g3.4+g3.5+g3.6+g3.7)
  p3.3 = g3.3 / (g3.1+g3.2+g3.3+g3.4+g3.5+g3.6+g3.7)
  p3.4 = g3.4 / (g3.1+g3.2+g3.3+g3.4+g3.5+g3.6+g3.7)
  p3.5 = g3.5 / (g3.1+g3.2+g3.3+g3.4+g3.5+g3.6+g3.7)
  p3.6 = g3.6 / (g3.1+g3.2+g3.3+g3.4+g3.5+g3.6+g3.7)
  p3.7 = g3.7 / (g3.1+g3.2+g3.3+g3.4+g3.5+g3.6+g3.7)
  
  p3 = cbind(p3.1, p3.2, p3.3, p3.4, p3.5, p3.6, p3.7)
  
  miss.3 = c()
  for(i in 1:length(id3)){
    miss0.3 = which.max(rmultinom(1, size = 1, prob = p3[i,]))
    miss.3 = c(miss.3, miss0.3)
  }
  
  id3.1 = which(miss.3 == 1)
  id3.2 = which(miss.3 == 2)
  id3.3 = which(miss.3 == 3)
  id3.4 = which(miss.3 == 4)
  id3.5 = which(miss.3 == 5)
  id3.6 = which(miss.3 == 6)
  id3.7 = which(miss.3 == 7)
  ## The end of dividing the missing block when y = 3 ##
  
  
  ## Divide the missing block ##
  id.1 = c(id1[id1.1], id2[id2.1], id3[id3.1])
  id.2 = c(id1[id1.2], id2[id2.2], id3[id3.2])
  id.3 = c(id1[id1.3], id2[id2.3], id3[id3.3])
  id.4 = c(id1[id1.4], id2[id2.4], id3[id3.4])
  id.5 = c(id1[id1.5], id2[id2.5], id3[id3.5])
  id.6 = c(id1[id1.6], id2[id2.6], id3[id3.6])
  id.7 = c(id1[id1.7], id2[id2.7], id3[id3.7])
  
  NN = c()
  NN[1] = length(id.1)
  NN[2] = length(id.2)
  NN[3] = length(id.3)
  NN[4] = length(id.4)
  NN[5] = length(id.5)
  NN[6] = length(id.6)
  NN[7] = length(id.7)
  
  y.new = c(y[id.1], y[id.2], y[id.3], y[id.4], y[id.5], y[id.6], y[id.7])
  x.new = rbind(x[id.1,], x[id.2,], x[id.3,], x[id.4,], x[id.5,], x[id.6,], x[id.7,])
  rho.new = rbind(rho[id.1,], rho[id.2,], rho[id.3,], rho[id.4,], rho[id.5,], rho[id.6,], rho[id.7,])
  ## The end of dividing the missing block ##
  
  return(list(NN, rho.new, x.new, y.new))
}